module.exports = (config, options) ->
	path = require 'path'
	log  = require "#{config.req.helpers}/log"
	test = require("#{config.req.helpers}/test")()

	# modules
	# =======
	rbModules  = ['body-parser', 'express', 'jasmine-expect', 'q']
	appModules = options.server.node_modules or []

	# http proxy
	# ==========
	rbModules.push 'http-proxy-middleware' if config.httpProxy.length

	# init node_modules
	# =================
	node_modules =
		rb:
			modules: rbModules
			dist: dir: null, modules: {}
			src:  dir: null, relPath: null, modules: {}
		app:
			modules: appModules
			dist: dir: null, modules: {}
			src:  dir: null, relPath: null, modules: {}

	# dist and src
	# ============
	addDistAndSrc = ->
		nmDir = 'node_modules'
		for appOrRb, v1 of node_modules
			for k2, v2 of v1
				continue unless k2 is 'dist' or k2 is 'src'
				switch k2
					when 'dist'
						dir = config.dist[appOrRb].server.scripts.dir
						v2.dir = path.join dir, nmDir
					when 'src'
						dir = config[appOrRb].dir
						v2.dir     = path.join dir, nmDir
						v2.relPath = nmDir
						continue if appOrRb is 'app'
						v2.relPath = path.join nmDir, config.rb.name, nmDir

	addDistAndSrc()

	# modules to copy to server dist
	# ==============================
	addModulesLocPaths = (appOrRb) ->
		for appOrRb, v of node_modules
			for module in node_modules[appOrRb].modules
				for loc in ['dist', 'src']
					_path = path.join node_modules[appOrRb][loc].dir, module
					node_modules[appOrRb][loc].modules[module] = _path

	addModulesLocPaths()

	# add node_modules to config
	# ==========================
	config.node_modules = node_modules

	# logs
	# ====
	# log.json node_modules, 'node_modules ='

	# tests
	# =====
	test.log 'true', config.node_modules, 'add node_modules to config'

	# return
	# ======
	config